Refactor a hash table solution to twoSum

Is this part of the description of the Archfey warlock's Misty Escape feature redundant?

A variation to the phrase "hanging over my shoulders"

Why do ¬, ∀ and ∃ have the same precedence?

Why can't the Brexit deadlock in the UK parliament be solved with a plurality vote?

C++ check if statement can be evaluated constexpr

Shouldn’t conservatives embrace universal basic income?

Pre-mixing cryogenic fuels and using only one fuel tank

Can I say "fingers" when referring to toes?

How much theory knowledge is actually used while playing?

Did the UK lift the requirement for registering SIM cards?

What does Apple's new App Store requirement mean

Can you use Vicious Mockery to win an argument or gain favours?

Review your own paper in Mathematics

Why do Radio Buttons not fill the entire outer circle?

Strong empirical falsification of quantum mechanics based on vacuum energy density?

Has the laser at Magurele, Romania reached a tenth of the Sun's power?

The IT department bottlenecks progress, how should I handle this?

Why Shazam when there is already Superman?

Is there any evidence that Cleopatra and Caesarion considered fleeing to India to escape the Romans?

How do I fix the group tension caused by my character stealing and possibly killing without provocation?

Microchip documentation does not label CAN buss pins on micro controller pinout diagram

Why does Carol not get rid of the Kree symbol on her suit when she changes its colours?

What are some good ways to treat frozen vegetables such that they behave like fresh vegetables when stir frying them?

Does an advisor owe his/her student anything? Will an advisor keep a PhD student only out of pity?



Refactor a hash table solution to twoSum














0












$begingroup$


I try the most to solve a twoSum problem in leetcode




Given an array of integers, return indices of the two numbers such that they add up to a specific target.



You may assume that each input would have exactly one solution, and you may not use the same element twice.



Example:



Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].



The plan:



1) brute force to iterate len(nums) O(n)

2) search for target - num[i] with a hash table O(1)



Implement



class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
nums_d =
for i in range(len(nums)):
nums_d.setdefault(nums[i], []).append(i)

for i in range(len(nums)):
sub_target = target - nums[i]
nums_d[nums[i]].pop(0) #remove the fixer
result = nums_d.get(sub_target)#hash table to search

if result:
return [i, result[0]]
return []


I strives hours for this solution but found that answer accepted but not passed Score 60.




Runtime: 60 ms, faster than 46.66% of Python3 online submissions for Two Sum.
Memory Usage: 16.1 MB, less than 5.08% of Python3 online submissions for Two Sum.




I want to refactor the codes so that to achieve at least faster than 60%.



Could you please provide hints?









share







New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







$endgroup$
















    0












    $begingroup$


    I try the most to solve a twoSum problem in leetcode




    Given an array of integers, return indices of the two numbers such that they add up to a specific target.



    You may assume that each input would have exactly one solution, and you may not use the same element twice.



    Example:



    Given nums = [2, 7, 11, 15], target = 9,

    Because nums[0] + nums[1] = 2 + 7 = 9,
    return [0, 1].



    The plan:



    1) brute force to iterate len(nums) O(n)

    2) search for target - num[i] with a hash table O(1)



    Implement



    class Solution:
    def twoSum(self, nums: List[int], target: int) -> List[int]:
    nums_d =
    for i in range(len(nums)):
    nums_d.setdefault(nums[i], []).append(i)

    for i in range(len(nums)):
    sub_target = target - nums[i]
    nums_d[nums[i]].pop(0) #remove the fixer
    result = nums_d.get(sub_target)#hash table to search

    if result:
    return [i, result[0]]
    return []


    I strives hours for this solution but found that answer accepted but not passed Score 60.




    Runtime: 60 ms, faster than 46.66% of Python3 online submissions for Two Sum.
    Memory Usage: 16.1 MB, less than 5.08% of Python3 online submissions for Two Sum.




    I want to refactor the codes so that to achieve at least faster than 60%.



    Could you please provide hints?









    share







    New contributor




    Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.







    $endgroup$














      0












      0








      0





      $begingroup$


      I try the most to solve a twoSum problem in leetcode




      Given an array of integers, return indices of the two numbers such that they add up to a specific target.



      You may assume that each input would have exactly one solution, and you may not use the same element twice.



      Example:



      Given nums = [2, 7, 11, 15], target = 9,

      Because nums[0] + nums[1] = 2 + 7 = 9,
      return [0, 1].



      The plan:



      1) brute force to iterate len(nums) O(n)

      2) search for target - num[i] with a hash table O(1)



      Implement



      class Solution:
      def twoSum(self, nums: List[int], target: int) -> List[int]:
      nums_d =
      for i in range(len(nums)):
      nums_d.setdefault(nums[i], []).append(i)

      for i in range(len(nums)):
      sub_target = target - nums[i]
      nums_d[nums[i]].pop(0) #remove the fixer
      result = nums_d.get(sub_target)#hash table to search

      if result:
      return [i, result[0]]
      return []


      I strives hours for this solution but found that answer accepted but not passed Score 60.




      Runtime: 60 ms, faster than 46.66% of Python3 online submissions for Two Sum.
      Memory Usage: 16.1 MB, less than 5.08% of Python3 online submissions for Two Sum.




      I want to refactor the codes so that to achieve at least faster than 60%.



      Could you please provide hints?









      share







      New contributor




      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.







      $endgroup$




      I try the most to solve a twoSum problem in leetcode




      Given an array of integers, return indices of the two numbers such that they add up to a specific target.



      You may assume that each input would have exactly one solution, and you may not use the same element twice.



      Example:



      Given nums = [2, 7, 11, 15], target = 9,

      Because nums[0] + nums[1] = 2 + 7 = 9,
      return [0, 1].



      The plan:



      1) brute force to iterate len(nums) O(n)

      2) search for target - num[i] with a hash table O(1)



      Implement



      class Solution:
      def twoSum(self, nums: List[int], target: int) -> List[int]:
      nums_d =
      for i in range(len(nums)):
      nums_d.setdefault(nums[i], []).append(i)

      for i in range(len(nums)):
      sub_target = target - nums[i]
      nums_d[nums[i]].pop(0) #remove the fixer
      result = nums_d.get(sub_target)#hash table to search

      if result:
      return [i, result[0]]
      return []


      I strives hours for this solution but found that answer accepted but not passed Score 60.




      Runtime: 60 ms, faster than 46.66% of Python3 online submissions for Two Sum.
      Memory Usage: 16.1 MB, less than 5.08% of Python3 online submissions for Two Sum.




      I want to refactor the codes so that to achieve at least faster than 60%.



      Could you please provide hints?







      algorithm





      share







      New contributor




      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.










      share







      New contributor




      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.








      share



      share






      New contributor




      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.









      asked 54 secs ago









      AliceAlice

      101




      101




      New contributor




      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.





      New contributor





      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.






      Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.




















          0






          active

          oldest

          votes











          Your Answer





          StackExchange.ifUsing("editor", function ()
          return StackExchange.using("mathjaxEditing", function ()
          StackExchange.MarkdownEditor.creationCallbacks.add(function (editor, postfix)
          StackExchange.mathjaxEditing.prepareWmdForMathJax(editor, postfix, [["\$", "\$"]]);
          );
          );
          , "mathjax-editing");

          StackExchange.ifUsing("editor", function ()
          StackExchange.using("externalEditor", function ()
          StackExchange.using("snippets", function ()
          StackExchange.snippets.init();
          );
          );
          , "code-snippets");

          StackExchange.ready(function()
          var channelOptions =
          tags: "".split(" "),
          id: "196"
          ;
          initTagRenderer("".split(" "), "".split(" "), channelOptions);

          StackExchange.using("externalEditor", function()
          // Have to fire editor after snippets, if snippets enabled
          if (StackExchange.settings.snippets.snippetsEnabled)
          StackExchange.using("snippets", function()
          createEditor();
          );

          else
          createEditor();

          );

          function createEditor()
          StackExchange.prepareEditor(
          heartbeatType: 'answer',
          autoActivateHeartbeat: false,
          convertImagesToLinks: false,
          noModals: true,
          showLowRepImageUploadWarning: true,
          reputationToPostImages: null,
          bindNavPrevention: true,
          postfix: "",
          imageUploader:
          brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
          contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
          allowUrls: true
          ,
          onDemand: true,
          discardSelector: ".discard-answer"
          ,immediatelyShowMarkdownHelp:true
          );



          );






          Alice is a new contributor. Be nice, and check out our Code of Conduct.









          draft saved

          draft discarded


















          StackExchange.ready(
          function ()
          StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcodereview.stackexchange.com%2fquestions%2f215975%2frefactor-a-hash-table-solution-to-twosum%23new-answer', 'question_page');

          );

          Post as a guest















          Required, but never shown

























          0






          active

          oldest

          votes








          0






          active

          oldest

          votes









          active

          oldest

          votes






          active

          oldest

          votes








          Alice is a new contributor. Be nice, and check out our Code of Conduct.









          draft saved

          draft discarded


















          Alice is a new contributor. Be nice, and check out our Code of Conduct.












          Alice is a new contributor. Be nice, and check out our Code of Conduct.











          Alice is a new contributor. Be nice, and check out our Code of Conduct.














          Thanks for contributing an answer to Code Review Stack Exchange!


          • Please be sure to answer the question. Provide details and share your research!

          But avoid


          • Asking for help, clarification, or responding to other answers.

          • Making statements based on opinion; back them up with references or personal experience.

          Use MathJax to format equations. MathJax reference.


          To learn more, see our tips on writing great answers.




          draft saved


          draft discarded














          StackExchange.ready(
          function ()
          StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcodereview.stackexchange.com%2fquestions%2f215975%2frefactor-a-hash-table-solution-to-twosum%23new-answer', 'question_page');

          );

          Post as a guest















          Required, but never shown





















































          Required, but never shown














          Required, but never shown












          Required, but never shown







          Required, but never shown

































          Required, but never shown














          Required, but never shown












          Required, but never shown







          Required, but never shown







          Popular posts from this blog

          कुँवर स्रोत दिक्चालन सूची"कुँवर""राणा कुँवरके वंशावली"

          Why is a white electrical wire connected to 2 black wires?How to wire a light fixture with 3 white wires in box?How should I wire a ceiling fan when there's only three wires in the box?Two white, two black, two ground, and red wire in ceiling box connected to switchWhy is there a white wire connected to multiple black wires in my light box?How to wire a light with two white wires and one black wireReplace light switch connected to a power outlet with dimmer - two black wires to one black and redHow to wire a light with multiple black/white/green wires from the ceiling?Ceiling box has 2 black and white wires but fan/ light only has 1 of eachWhy neutral wire connected to load wire?Switch with 2 black, 2 white, 2 ground and 1 red wire connected to ceiling light and a receptacle?

          चैत्य भूमि चित्र दीर्घा सन्दर्भ बाहरी कडियाँ दिक्चालन सूची"Chaitya Bhoomi""Chaitya Bhoomi: Statue of Equality in India""Dadar Chaitya Bhoomi: Statue of Equality in India""Ambedkar memorial: Centre okays transfer of Indu Mill land"चैत्यभमि